import 'package:flutter/widgets.dart';

import 'restart_config.dart';
import 'restart_controller.dart';

// Kudos to Tomasz Polanski:
// https://github.com/tomaszpolanski/flutter-animations/blob/05377863f5bd0e801a7ffa050fff4e070e712fad/lib/tests/src/restart_widget.dart
class RestartWidget extends StatelessWidget {
  const RestartWidget({
    Key? key,
    required this.restartController,
    required this.builder,
  }) : super(key: key);

  final RestartController restartController;
  final Widget Function(BuildContext, String) builder;

  Stream<RestartConfig?> _invalidate(RestartConfig? config) async* {
    yield null;
    await Future.delayed(const Duration(milliseconds: 16));
    yield config!;
  }

  @override
  Widget build(BuildContext context) {
    return StreamBuilder<RestartConfig>(
      stream: restartController.stream,
      initialData: RestartConfig("initial-app-run", null),
      builder: (context, snapshot) {
        return StreamBuilder(
          initialData: snapshot.data,
          stream: _invalidate(snapshot.data),
          builder: (context, AsyncSnapshot<RestartConfig?> snapshot) {
            if (snapshot.data == null) return SizedBox();
            return Container(
              key: Key(snapshot.data!.key),
              child: builder(context, snapshot.data!.configuration ?? ""),
            );
          },
        );
      },
    );
  }
}
